Index: ruby/trunk/adl_parser/tests/openEHR-EHR-CLUSTER.exam-chest.v1.adl
===================================================================
--- ruby/trunk/adl_parser/tests/openEHR-EHR-CLUSTER.exam-chest.v1.adl	(revision 4)
+++ ruby/trunk/adl_parser/tests/openEHR-EHR-CLUSTER.exam-chest.v1.adl	(revision 35)
@@ -1,379 +1,379 @@
 archetype (adl_version=1.4)
-	openEHR-EHR-CLUSTER.exam-chest.v1
+        openEHR-EHR-CLUSTER.exam-chest.v1
 specialize
-	openEHR-EHR-CLUSTER.exam.v1
+        openEHR-EHR-CLUSTER.exam.v1
 
 concept
-	[at0000.1]	-- Examination of the chest
+        [at0000.1]      -- Examination of the chest
 language
-	original_language = <[ISO_639-1::en]>
+        original_language = <[ISO_639-1::en]>
 description
-	original_author = <
-		["name"] = <"Sam Heard">
-		["organisation"] = <"Ocean Informatics">
-		["date"] = <"9/04/2007">
-		["email"] = <"Sam.Heard@OceanInformatics.biz">
-	>
-	details = <
-		["en"] = <
-			language = <[ISO_639-1::en]>
-			purpose = <"A cluster for recording findings on physical examination of the chest">
-			use = <"">
-			keywords = <"examination", "physical", "chest", "thorax", "lungs">
-			misuse = <"">
-		>
-	>
-	lifecycle_state = <"Initial">
-	other_contributors = <>
+        original_author = <
+                ["name"] = <"Sam Heard">
+                ["organisation"] = <"Ocean Informatics">
+                ["date"] = <"9/04/2007">
+                ["email"] = <"Sam.Heard@OceanInformatics.biz">
+        >
+        details = <
+                ["en"] = <
+                        language = <[ISO_639-1::en]>
+                        purpose = <"A cluster for recording findings on physical examination of the chest">
+                        use = <"">
+                        keywords = <"examination", "physical", "chest", "thorax", "lungs">
+                        misuse = <"">
+                >
+        >
+        lifecycle_state = <"Initial">
+        other_contributors = <>
 
 definition
-	CLUSTER[at0000.1] matches {	-- Examination of the chest
-		items cardinality matches {0..*; unordered} matches {
-			CLUSTER[at0004] occurrences matches {0..1} matches {	-- Normal statements
-				items cardinality matches {0..*; unordered} matches {
-					ELEMENT[at0005] occurrences matches {0..*} matches {	-- Normal statement
-						value matches {
-							DV_TEXT matches {*}
-						}
-					}
-				}
-			}
-			ELEMENT[at0002] occurrences matches {0..1} matches {	-- Clinical description
-				value matches {
-					DV_TEXT matches {*}
-				}
-			}
-			CLUSTER[at0008] occurrences matches {0..1} matches {	-- Findings
-				items cardinality matches {0..*; unordered} matches {
-					CLUSTER[at0.1] occurrences matches {0..1} matches {	-- Chest wall
-						items cardinality matches {0..*; unordered} matches {
-							ELEMENT[at0.2] occurrences matches {0..1} matches {	-- Description
-								value matches {
-									DV_CODED_TEXT matches {
-										defining_code matches {[local::]}
-									}
-								}
-							}
-							ELEMENT[at0.28] occurrences matches {0..1} matches {	-- Shape
-								value matches {
-									DV_TEXT matches {*}
-								}
-							}
-							CLUSTER[at0.30] occurrences matches {0..1} matches {	-- Heart - Apex beat
-								items cardinality matches {0..*; unordered} matches {
-									ELEMENT[at0.31] occurrences matches {0..1} matches {	-- Visible
-										value matches {
-											DV_BOOLEAN matches {
-												value matches {True, False}
-											}
-										}
-									}
-									CLUSTER[at0.32] occurrences matches {0..1} matches {	-- Palpation
-										items cardinality matches {0..*; unordered} matches {
-											ELEMENT[at0.33] occurrences matches {0..1} matches {	-- Palpable
-												value matches {
-													DV_BOOLEAN matches {
-														value matches {True, False}
-													}
-												}
-											}
-											ELEMENT[at0.34] occurrences matches {0..1} matches {	-- Maximal location
-												value matches {
-													DV_TEXT matches {*}
-												}
-											}
-										}
-									}
-								}
-							}
-							allow_archetype CLUSTER occurrences matches {0..1} matches {
-								include
-									archetype_id/value matches {/palpation\.v1draft/}
-									archetype_id/value matches {/inspection\.v1draft/}
-									archetype_id/value matches {/auscultation-chest\.v1/}
-							}
-						}
-					}
-					CLUSTER[at0.3] occurrences matches {0..1} matches {	-- Respiratory system
-						items cardinality matches {0..*; unordered} matches {
-							ELEMENT[at0.4] occurrences matches {0..1} matches {	-- Trachea
-								value matches {
-									DV_CODED_TEXT matches {
-										defining_code matches {
-											[local::
-											at0.5, 	-- Midline
-											at0.6, 	-- Deviated to the left
-											at0.7]	-- Deviated to the right
-										}
-									}
-								}
-							}
-							CLUSTER[at0.8] occurrences matches {0..1} matches {	-- Breathing
-								items cardinality matches {0..*; unordered} matches {
-									ELEMENT[at0.19] occurrences matches {0..1} matches {	-- Description
-										value matches {
-											DV_TEXT matches {*}
-										}
-									}
-									ELEMENT[at0.9] occurrences matches {0..1} matches {	-- Type
-										value matches {
-											DV_CODED_TEXT matches {
-												defining_code matches {
-													[local::
-													at0.10, 	-- Diaphragmatic breathing
-													at0.11]	-- Thoracic breathing
-												}
-											}
-										}
-									}
-									ELEMENT[at0.12] occurrences matches {0..1} matches {	-- Effort
-										value matches {
-											5|[local::at0.13], 	-- Normal breathing effort
-											6|[local::at0.14], 	-- Mild increase in effort
-											8|[local::at0.15], 	-- Moderate increased effort
-											10|[local::at0.16]  	-- Major increased effort
-										}
-									}
-									CLUSTER[at0.17] occurrences matches {0..1} matches {	-- Signs of increased effort
-										items cardinality matches {0..*; unordered} matches {
-											ELEMENT[at0.18] occurrences matches {0..*} matches {	-- Sign
-												value matches {
-													DV_CODED_TEXT matches {
-														defining_code matches {
-															[local::
-															at0.25, 	-- Using accessory muscles
-															at0.20, 	-- Intercostal recession
-															at0.24, 	-- Subcostal recession
-															at0.23, 	-- Suprasternal recession
-															at0.21, 	-- Sternal recession
-															at0.22]	-- Rib retraction
-														}
-													}
-												}
-											}
-										}
-									}
-									ELEMENT[at0.26] occurrences matches {0..1} matches {	-- Paradoxical movement (flail chest)
-										value matches {
-											DV_BOOLEAN matches {
-												value matches {True, False}
-											}
-										}
-									}
-								}
-							}
-						}
-					}
-					CLUSTER[at0003] occurrences matches {0..1} matches {	-- Detail
-						items cardinality matches {0..*; unordered} matches {
-							allow_archetype CLUSTER occurrences matches {0..1} matches {
-								include
-									archetype_id/value matches {/exam-generic\.v1/}
-									archetype_id/value matches {/auscultation-chest\.v1/}
-									archetype_id/value matches {/palpation\.v1/}
-									archetype_id/value matches {/inspection\.v1draft/}
-									archetype_id/value matches {/percussion\.v1/}
-							}
-						}
-					}
-				}
-			}
-			CLUSTER[at0.27] occurrences matches {0..1} matches {	-- Lymph nodes
-				items cardinality matches {0..*; unordered} matches {
-					allow_archetype CLUSTER occurrences matches {0..1} matches {
-						include
-							archetype_id/value matches {/exam-generic-lympnode\.v1/}
-					}
-				}
-			}
-			ELEMENT[at0006] occurrences matches {0..*} matches {	-- Image
-				value matches {
-					DV_MULTIMEDIA matches {
-						media_type matches {
-							[openEHR::
-							426, 
-							427, 
-							429]
-						}
-					}
-				}
-			}
-		}
-	}
+        CLUSTER[at0000.1] matches {     -- Examination of the chest
+                items cardinality matches {0..*; unordered} matches {
+                        CLUSTER[at0004] occurrences matches {0..1} matches {    -- Normal statements
+                                items cardinality matches {0..*; unordered} matches {
+                                        ELEMENT[at0005] occurrences matches {0..*} matches {    -- Normal statement
+                                                value matches {
+                                                        DV_TEXT matches {*}
+                                                }
+                                        }
+                                }
+                        }
+                        ELEMENT[at0002] occurrences matches {0..1} matches {    -- Clinical description
+                                value matches {
+                                        DV_TEXT matches {*}
+                                }
+                        }
+                        CLUSTER[at0008] occurrences matches {0..1} matches {    -- Findings
+                                items cardinality matches {0..*; unordered} matches {
+                                        CLUSTER[at0.1] occurrences matches {0..1} matches {     -- Chest wall
+                                                items cardinality matches {0..*; unordered} matches {
+                                                        ELEMENT[at0.2] occurrences matches {0..1} matches {     -- Description
+                                                                value matches {
+                                                                        DV_CODED_TEXT matches {
+                                                                                defining_code matches {[local::]}
+                                                                        }
+                                                                }
+                                                        }
+                                                        ELEMENT[at0.28] occurrences matches {0..1} matches {    -- Shape
+                                                                value matches {
+                                                                        DV_TEXT matches {*}
+                                                                }
+                                                        }
+                                                        CLUSTER[at0.30] occurrences matches {0..1} matches {    -- Heart - Apex beat
+                                                                items cardinality matches {0..*; unordered} matches {
+                                                                        ELEMENT[at0.31] occurrences matches {0..1} matches {    -- Visible
+                                                                                value matches {
+                                                                                        DV_BOOLEAN matches {
+                                                                                                value matches {True, False}
+                                                                                        }
+                                                                                }
+                                                                        }
+                                                                        CLUSTER[at0.32] occurrences matches {0..1} matches {    -- Palpation
+                                                                                items cardinality matches {0..*; unordered} matches {
+                                                                                        ELEMENT[at0.33] occurrences matches {0..1} matches {    -- Palpable
+                                                                                                value matches {
+                                                                                                        DV_BOOLEAN matches {
+                                                                                                                value matches {True, False}
+                                                                                                        }
+                                                                                                }
+                                                                                        }
+                                                                                        ELEMENT[at0.34] occurrences matches {0..1} matches {    -- Maximal location
+                                                                                                value matches {
+                                                                                                        DV_TEXT matches {*}
+                                                                                                }
+                                                                                        }
+                                                                                }
+                                                                        }
+                                                                }
+                                                        }
+                                                        allow_archetype CLUSTER occurrences matches {0..1} matches {
+                                                                include
+                                                                        archetype_id/value matches {/palpation\.v1draft/}
+                                                                        archetype_id/value matches {/inspection\.v1draft/}
+                                                                        archetype_id/value matches {/auscultation-chest\.v1/}
+                                                        }
+                                                }
+                                        }
+                                        CLUSTER[at0.3] occurrences matches {0..1} matches {     -- Respiratory system
+                                                items cardinality matches {0..*; unordered} matches {
+                                                        ELEMENT[at0.4] occurrences matches {0..1} matches {     -- Trachea
+                                                                value matches {
+                                                                        DV_CODED_TEXT matches {
+                                                                                defining_code matches {
+                                                                                        [local::
+                                                                                        at0.5,  -- Midline
+                                                                                        at0.6,  -- Deviated to the left
+                                                                                        at0.7]  -- Deviated to the right
+                                                                                }
+                                                                        }
+                                                                }
+                                                        }
+                                                        CLUSTER[at0.8] occurrences matches {0..1} matches {     -- Breathing
+                                                                items cardinality matches {0..*; unordered} matches {
+                                                                        ELEMENT[at0.19] occurrences matches {0..1} matches {    -- Description
+                                                                                value matches {
+                                                                                        DV_TEXT matches {*}
+                                                                                }
+                                                                        }
+                                                                        ELEMENT[at0.9] occurrences matches {0..1} matches {     -- Type
+                                                                                value matches {
+                                                                                        DV_CODED_TEXT matches {
+                                                                                                defining_code matches {
+                                                                                                        [local::
+                                                                                                        at0.10,         -- Diaphragmatic breathing
+                                                                                                        at0.11] -- Thoracic breathing
+                                                                                                }
+                                                                                        }
+                                                                                }
+                                                                        }
+                                                                        ELEMENT[at0.12] occurrences matches {0..1} matches {    -- Effort
+                                                                                value matches {
+                                                                                        5|[local::at0.13],      -- Normal breathing effort
+                                                                                        6|[local::at0.14],      -- Mild increase in effort
+                                                                                        8|[local::at0.15],      -- Moderate increased effort
+                                                                                        10|[local::at0.16]      -- Major increased effort
+                                                                                }
+                                                                        }
+                                                                        CLUSTER[at0.17] occurrences matches {0..1} matches {    -- Signs of increased effort
+                                                                                items cardinality matches {0..*; unordered} matches {
+                                                                                        ELEMENT[at0.18] occurrences matches {0..*} matches {    -- Sign
+                                                                                                value matches {
+                                                                                                        DV_CODED_TEXT matches {
+                                                                                                                defining_code matches {
+                                                                                                                        [local::
+                                                                                                                        at0.25,         -- Using accessory muscles
+                                                                                                                        at0.20,         -- Intercostal recession
+                                                                                                                        at0.24,         -- Subcostal recession
+                                                                                                                        at0.23,         -- Suprasternal recession
+                                                                                                                        at0.21,         -- Sternal recession
+                                                                                                                        at0.22] -- Rib retraction
+                                                                                                                }
+                                                                                                        }
+                                                                                                }
+                                                                                        }
+                                                                                }
+                                                                        }
+                                                                        ELEMENT[at0.26] occurrences matches {0..1} matches {    -- Paradoxical movement (flail chest)
+                                                                                value matches {
+                                                                                        DV_BOOLEAN matches {
+                                                                                                value matches {True, False}
+                                                                                        }
+                                                                                }
+                                                                        }
+                                                                }
+                                                        }
+                                                }
+                                        }
+                                        CLUSTER[at0003] occurrences matches {0..1} matches {    -- Detail
+                                                items cardinality matches {0..*; unordered} matches {
+                                                        allow_archetype CLUSTER occurrences matches {0..1} matches {
+                                                                include
+                                                                        archetype_id/value matches {/exam-generic\.v1/}
+                                                                        archetype_id/value matches {/auscultation-chest\.v1/}
+                                                                        archetype_id/value matches {/palpation\.v1/}
+                                                                        archetype_id/value matches {/inspection\.v1draft/}
+                                                                        archetype_id/value matches {/percussion\.v1/}
+                                                        }
+                                                }
+                                        }
+                                }
+                        }
+                        CLUSTER[at0.27] occurrences matches {0..1} matches {    -- Lymph nodes
+                                items cardinality matches {0..*; unordered} matches {
+                                        allow_archetype CLUSTER occurrences matches {0..1} matches {
+                                                include
+                                                        archetype_id/value matches {/exam-generic-lympnode\.v1/}
+                                        }
+                                }
+                        }
+                        ELEMENT[at0006] occurrences matches {0..*} matches {    -- Image
+                                value matches {
+                                        DV_MULTIMEDIA matches {
+                                                media_type matches {
+                                                        [openEHR::
+                                                        426, 
+                                                        427, 
+                                                        429]
+                                                }
+                                        }
+                                }
+                        }
+                }
+        }
 
 ontology
-	term_definitions = <
-		["en"] = <
-			items = <
-				["at0.1"] = <
-					description = <"Findings about the chest wall">
-					text = <"Chest wall">
-				>
-				["at0.10"] = <
-					description = <"Breathing using the diaphragm and not the chest wall">
-					text = <"Diaphragmatic breathing">
-				>
-				["at0.11"] = <
-					description = <"Breathing using expansion of the chest wall">
-					text = <"Thoracic breathing">
-				>
-				["at0.12"] = <
-					description = <"Effort required for breathing">
-					text = <"Effort">
-				>
-				["at0.13"] = <
-					description = <"Diaphragmatic breathing as at rest">
-					text = <"Normal breathing effort">
-				>
-				["at0.14"] = <
-					description = <"Breathing using obvious chest expansion">
-					text = <"Mild increase in effort">
-				>
-				["at0.15"] = <
-					description = <"Breathing with signs of abnormal breathing">
-					text = <"Moderate increased effort">
-				>
-				["at0.16"] = <
-					description = <"Many signs of increased breathing effort">
-					text = <"Major increased effort">
-				>
-				["at0.17"] = <
-					description = <"Signs of increased respiratory effort">
-					text = <"Signs of increased effort">
-				>
-				["at0.18"] = <
-					description = <"Use of accessory respiratory muscles">
-					text = <"Sign">
-				>
-				["at0.19"] = <
-					description = <"Description of breathing">
-					text = <"Description">
-				>
-				["at0.2"] = <
-					description = <"The contour of the chest wall">
-					text = <"Description">
-				>
-				["at0.20"] = <
-					description = <"Drawing in between the ribs on inspiration">
-					text = <"Intercostal recession">
-				>
-				["at0.21"] = <
-					description = <"Drawing in of the sternum on inspiration">
-					text = <"Sternal recession">
-				>
-				["at0.22"] = <
-					description = <"Indrawing of the chest wall on inspiration">
-					text = <"Rib retraction">
-				>
-				["at0.23"] = <
-					description = <"Indrawing above the sternum on inspiration">
-					text = <"Suprasternal recession">
-				>
-				["at0.24"] = <
-					description = <"Indrawing of the subcostal abdominal wall ">
-					text = <"Subcostal recession">
-				>
-				["at0.25"] = <
-					description = <"Use of accessory respiratory muscles during inspiration">
-					text = <"Using accessory muscles">
-				>
-				["at0.26"] = <
-					description = <"Any paradoxical movement of the chest wall during respiration">
-					text = <"Paradoxical movement (flail chest)">
-				>
-				["at0.27"] = <
-					description = <"Lymphnodes">
-					text = <"Lymph nodes">
-				>
-				["at0.28"] = <
-					description = <"The shape of the chest">
-					text = <"Shape">
-					comment = <"ChestShape SNOMED query">
-				>
-				["at0.29"] = <
-					description = <"Pidgeon chest, with prominent lower sternum">
-					text = <"Pectus carinatum">
-				>
-				["at0.3"] = <
-					description = <"Respiratory findings">
-					text = <"Respiratory system">
-				>
-				["at0.30"] = <
-					description = <"*">
-					text = <"Heart - Apex beat">
-				>
-				["at0.31"] = <
-					description = <"Apex beat is visible">
-					text = <"Visible">
-				>
-				["at0.32"] = <
-					description = <"*">
-					text = <"Palpation">
-				>
-				["at0.33"] = <
-					description = <"Apex beat is palpable">
-					text = <"Palpable">
-				>
-				["at0.34"] = <
-					description = <"Site of maximal location of apex beat">
-					text = <"Maximal location">
-				>
-				["at0.4"] = <
-					description = <"The position of the trachea">
-					text = <"Trachea">
-				>
-				["at0.5"] = <
-					description = <"The trachea is in the midline position">
-					text = <"Midline">
-				>
-				["at0.6"] = <
-					description = <"The trachea is deviated to the left">
-					text = <"Deviated to the left">
-				>
-				["at0.7"] = <
-					description = <"The trachea is deviated to the right">
-					text = <"Deviated to the right">
-				>
-				["at0.8"] = <
-					description = <"Findings about breathing">
-					text = <"Breathing">
-				>
-				["at0.9"] = <
-					description = <"Type of breathing">
-					text = <"Type">
-				>
-				["at0000"] = <
-					description = <"Basic examination cluster for describing findings on physical examination when there is no named focus of examination">
-					text = <"Examination">
-				>
-				["at0000.1"] = <
-					description = <"For recording findings on physical examination of the chest wall and lungs">
-					text = <"Examination of the chest">
-				>
-				["at0002"] = <
-					description = <"Textural description of the part examined">
-					text = <"Clinical description">
-				>
-				["at0003"] = <
-					description = <"More focused examination findings">
-					text = <"Detail">
-				>
-				["at0004"] = <
-					description = <"A group of statements about the normality of the examination">
-					text = <"Normal statements">
-				>
-				["at0005"] = <
-					description = <"A specific statement of normality">
-					text = <"Normal statement">
-				>
-				["at0006"] = <
-					description = <"Drawing or image of the area examined">
-					text = <"Image">
-				>
-				["at0008"] = <
-					description = <"Clinical findings">
-					text = <"Findings">
-				>
-			>
-		>
-	>
+        term_definitions = <
+                ["en"] = <
+                        items = <
+                                ["at0.1"] = <
+                                        description = <"Findings about the chest wall">
+                                        text = <"Chest wall">
+                                >
+                                ["at0.10"] = <
+                                        description = <"Breathing using the diaphragm and not the chest wall">
+                                        text = <"Diaphragmatic breathing">
+                                >
+                                ["at0.11"] = <
+                                        description = <"Breathing using expansion of the chest wall">
+                                        text = <"Thoracic breathing">
+                                >
+                                ["at0.12"] = <
+                                        description = <"Effort required for breathing">
+                                        text = <"Effort">
+                                >
+                                ["at0.13"] = <
+                                        description = <"Diaphragmatic breathing as at rest">
+                                        text = <"Normal breathing effort">
+                                >
+                                ["at0.14"] = <
+                                        description = <"Breathing using obvious chest expansion">
+                                        text = <"Mild increase in effort">
+                                >
+                                ["at0.15"] = <
+                                        description = <"Breathing with signs of abnormal breathing">
+                                        text = <"Moderate increased effort">
+                                >
+                                ["at0.16"] = <
+                                        description = <"Many signs of increased breathing effort">
+                                        text = <"Major increased effort">
+                                >
+                                ["at0.17"] = <
+                                        description = <"Signs of increased respiratory effort">
+                                        text = <"Signs of increased effort">
+                                >
+                                ["at0.18"] = <
+                                        description = <"Use of accessory respiratory muscles">
+                                        text = <"Sign">
+                                >
+                                ["at0.19"] = <
+                                        description = <"Description of breathing">
+                                        text = <"Description">
+                                >
+                                ["at0.2"] = <
+                                        description = <"The contour of the chest wall">
+                                        text = <"Description">
+                                >
+                                ["at0.20"] = <
+                                        description = <"Drawing in between the ribs on inspiration">
+                                        text = <"Intercostal recession">
+                                >
+                                ["at0.21"] = <
+                                        description = <"Drawing in of the sternum on inspiration">
+                                        text = <"Sternal recession">
+                                >
+                                ["at0.22"] = <
+                                        description = <"Indrawing of the chest wall on inspiration">
+                                        text = <"Rib retraction">
+                                >
+                                ["at0.23"] = <
+                                        description = <"Indrawing above the sternum on inspiration">
+                                        text = <"Suprasternal recession">
+                                >
+                                ["at0.24"] = <
+                                        description = <"Indrawing of the subcostal abdominal wall ">
+                                        text = <"Subcostal recession">
+                                >
+                                ["at0.25"] = <
+                                        description = <"Use of accessory respiratory muscles during inspiration">
+                                        text = <"Using accessory muscles">
+                                >
+                                ["at0.26"] = <
+                                        description = <"Any paradoxical movement of the chest wall during respiration">
+                                        text = <"Paradoxical movement (flail chest)">
+                                >
+                                ["at0.27"] = <
+                                        description = <"Lymphnodes">
+                                        text = <"Lymph nodes">
+                                >
+                                ["at0.28"] = <
+                                        description = <"The shape of the chest">
+                                        text = <"Shape">
+                                        comment = <"ChestShape SNOMED query">
+                                >
+                                ["at0.29"] = <
+                                        description = <"Pidgeon chest, with prominent lower sternum">
+                                        text = <"Pectus carinatum">
+                                >
+                                ["at0.3"] = <
+                                        description = <"Respiratory findings">
+                                        text = <"Respiratory system">
+                                >
+                                ["at0.30"] = <
+                                        description = <"*">
+                                        text = <"Heart - Apex beat">
+                                >
+                                ["at0.31"] = <
+                                        description = <"Apex beat is visible">
+                                        text = <"Visible">
+                                >
+                                ["at0.32"] = <
+                                        description = <"*">
+                                        text = <"Palpation">
+                                >
+                                ["at0.33"] = <
+                                        description = <"Apex beat is palpable">
+                                        text = <"Palpable">
+                                >
+                                ["at0.34"] = <
+                                        description = <"Site of maximal location of apex beat">
+                                        text = <"Maximal location">
+                                >
+                                ["at0.4"] = <
+                                        description = <"The position of the trachea">
+                                        text = <"Trachea">
+                                >
+                                ["at0.5"] = <
+                                        description = <"The trachea is in the midline position">
+                                        text = <"Midline">
+                                >
+                                ["at0.6"] = <
+                                        description = <"The trachea is deviated to the left">
+                                        text = <"Deviated to the left">
+                                >
+                                ["at0.7"] = <
+                                        description = <"The trachea is deviated to the right">
+                                        text = <"Deviated to the right">
+                                >
+                                ["at0.8"] = <
+                                        description = <"Findings about breathing">
+                                        text = <"Breathing">
+                                >
+                                ["at0.9"] = <
+                                        description = <"Type of breathing">
+                                        text = <"Type">
+                                >
+                                ["at0000"] = <
+                                        description = <"Basic examination cluster for describing findings on physical examination when there is no named focus of examination">
+                                        text = <"Examination">
+                                >
+                                ["at0000.1"] = <
+                                        description = <"For recording findings on physical examination of the chest wall and lungs">
+                                        text = <"Examination of the chest">
+                                >
+                                ["at0002"] = <
+                                        description = <"Textural description of the part examined">
+                                        text = <"Clinical description">
+                                >
+                                ["at0003"] = <
+                                        description = <"More focused examination findings">
+                                        text = <"Detail">
+                                >
+                                ["at0004"] = <
+                                        description = <"A group of statements about the normality of the examination">
+                                        text = <"Normal statements">
+                                >
+                                ["at0005"] = <
+                                        description = <"A specific statement of normality">
+                                        text = <"Normal statement">
+                                >
+                                ["at0006"] = <
+                                        description = <"Drawing or image of the area examined">
+                                        text = <"Image">
+                                >
+                                ["at0008"] = <
+                                        description = <"Clinical findings">
+                                        text = <"Findings">
+                                >
+                        >
+                >
+        >