Index: /ruby/trunk/lib/adl_parser/Rakefile
===================================================================
--- /ruby/trunk/lib/adl_parser/Rakefile	(revision 46)
+++ /ruby/trunk/lib/adl_parser/Rakefile	(revision 47)
@@ -10,6 +10,6 @@
 $DEBUG = false
 
-RACC_SRC = FileList["lib/*.y"]
-RACC_PARSER = FileList['lib/parser.rb']
+RACC_SRC = FileList["*.y"]
+RACC_PARSER = FileList['parser.rb']
 
 task :default => [:racc]
@@ -26,5 +26,5 @@
 
 
-RB_SRC = FileList["lib/*.rb"]
+RB_SRC = FileList["*.rb"]
 TAGS = FileList['TAGS']
 desc "Generate TAGS by rtags."
@@ -40,5 +40,5 @@
 
 Rake::TestTask.new('test:shell') do |t|
-  t.libs = ["lib"]
+#  t.libs = ["lib"]
   t.pattern = ['tests/shell_test.rb']
   t.warning = true
Index: by/trunk/lib/adl_parser/model.rb
===================================================================
--- /ruby/trunk/lib/adl_parser/model.rb	(revision 46)
+++ 	(revision )
@@ -1,102 +1,0 @@
-require 'logger'
-
-
-module OpenEHR
-  module ADL
-    module Model
-      module Archetype
-        class ARCHETYPE
-          attr_accessor :adl_version, :archetype_id, :uid, :concept, :parent_archetype_id, :definition, :ontology, :invariants
-
-          def version
-          end
-          
-          def previous_version
-          end
-
-          def short_concept_name
-          end
-
-          def concept_name
-          end
-          
-          def physical_path
-          end
-
-          def logiacl_path
-          end
-
-          def is_specialized
-          end
-
-          def specilisation_depth
-          end
-
-          def node_ids_valid
-          end
-
-          def internal_references_valid
-          end
-
-          def constraint_references_valid
-          end
-
-          def is_valid
-          end
-        end
-
-        
-        class ConstraintModel
-
-          class ArchetypeConstraint
-            def is_valid
-            end
-
-            def has_path
-            end
-
-            def path
-            end
-
-            def is_subset_of
-            end
-          end
-
-          class CObject
-          end
-
-          class CAttribute
-          end
-
-          class CSingleAttribute < CAttribute
-          end
-
-          class CMultipleAttribute < CAttribute
-          end
-
-          class CDefinedObject
-          end
-
-          class CComplexObject < CDefinedObject
-          end
-
-
-          class CPrimitiveObject < CDefinedObject
-          end
-
-          class CDomainType < CDefinedObject
-          end
-
-          class CReferenceObject < CObject
-          end
-        end
-
-        class Assertion
-        end
-
-        class Ontology
-        end
-      end
-    end
-  end
-end
Index: /ruby/trunk/lib/adl_parser/tests/shell_test.rb
===================================================================
--- /ruby/trunk/lib/adl_parser/tests/shell_test.rb	(revision 46)
+++ /ruby/trunk/lib/adl_parser/tests/shell_test.rb	(revision 47)
@@ -1,3 +1,3 @@
-require 'lib/shell.rb'
+require 'shell.rb'
 require 'test/unit'
 
Index: /ruby/trunk/lib/models/am/archetype/validity_kind.rb
===================================================================
--- /ruby/trunk/lib/models/am/archetype/validity_kind.rb	(revision 47)
+++ /ruby/trunk/lib/models/am/archetype/validity_kind.rb	(revision 47)
@@ -0,0 +1,20 @@
+module OpenEHR
+  module AM
+    module Archetype
+      class VALIDITY_KIND
+        attr_accessor :value
+        MANDATORY = 1001
+        OPTIONAL = 1002
+        DISALLOWED = 1003
+        
+        def initialize(arg)
+          @value = arg
+        end
+        
+        def valid_validity
+          
+        end
+      end
+    end # of Archetype
+  end # of AM
+end # of OpenEHR
Index: /ruby/trunk/lib/models/rm/support/assumed_types.rb
===================================================================
--- /ruby/trunk/lib/models/rm/support/assumed_types.rb	(revision 46)
+++ /ruby/trunk/lib/models/rm/support/assumed_types.rb	(revision 47)
@@ -16,4 +16,61 @@
           end
         end
+
+        class List
+          attr_reader :content
+
+          def initialize(arg)
+            @content = arg
+          end
+
+          def first
+            @content.first
+          end
+
+          def last
+            @content.last
+          end
+        end
+
+        class TIME_DEFINITIONS
+        end
+
+
+        class ISO8601_DATE < TIME_DEFINITIONS
+        end
+
+        class ISO8601_TIME < TIME_DEFINITIONS
+        end
+
+        class ISO8601_DURATION < TIME_DEFINITIONS
+        end
+
+        class ISO8601_DATE_TIME < TIME_DEFINITIONS
+        end
+
+        class ISO8601_TIMEZONE < TIME_DEFINITIONS
+        end
+
+        class String
+          attr_reader :content
+          def initialize(arg)
+            @content = arg
+          end
+
+          def as_integer
+            is_integer if is_integer
+          end
+
+          def is_empty
+          end
+
+          def is_integer
+            begin
+              Integer(@content)
+            rescue
+              false
+            end
+          end
+        end
       end
     end
Index: /ruby/trunk/lib/models/rm/support/support.rb
===================================================================
--- /ruby/trunk/lib/models/rm/support/support.rb	(revision 47)
+++ /ruby/trunk/lib/models/rm/support/support.rb	(revision 47)
@@ -0,0 +1,15 @@
+
+module OpenEHR
+  module RM
+    module Support
+      module External_Environment_Access
+        def eea_terminology_svc
+        end
+
+        def eea_measurement_svc
+        end
+      end
+
+    end
+  end
+end