Index: ruby/trunk/lib/adl_parser/lib/parser.rb
===================================================================
--- ruby/trunk/lib/adl_parser/parser.rb	(revision 45)
+++ ruby/trunk/lib/adl_parser/lib/parser.rb	(revision 49)
@@ -2,8 +2,9 @@
 # DO NOT MODIFY!!!!
 # This file is automatically generated by racc 1.4.5
-# from racc grammer file "parser.y".
+# from racc grammer file "lib/parser.y".
 #
 
 require 'racc/parser'
+
 
 
@@ -11,9 +12,9 @@
 $:.unshift File.join(File.dirname(__FILE__))
 require 'logger'
-require 'util.rb'
-require 'scanner.rb'
+#require 'lib/util.rb'
+#require 'lib/scanner.rb'
 require 'rubygems'
-require '../models/am.rb'
-$DEBUG = true
+require 'am.rb'
+$DEBUG = false
 
 
@@ -26,5 +27,5 @@
     class Parser < Racc::Parser
 
-module_eval <<'..end lib/parser.y modeval..idf8b8df4140', 'lib/parser.y', 1175
+module_eval <<'..end lib/parser.y modeval..idc8fd0a7fcc', 'lib/parser.y', 1182
 
 def assert_at(file,line, message = "")
@@ -34,5 +35,12 @@
 end
 
-@@log = Logger.new('log/parser.log','daily')
+if $DEBUG
+  @@log = Logger.new('log/parser.log','daily')
+  @@log.level = Logger::INFO
+else
+  @@log = Logger.new(STDOUT)
+  @@log.level = Logger::WARN
+end
+
 @@dadl_scanner = OpenEHR::ADL::Scanner::DADL::RootScanner.new
 @@cadl_scanner = OpenEHR::ADL::Scanner::CADL::RootScanner.new
@@ -819,5 +827,5 @@
 
 
-..end lib/parser.y modeval..idf8b8df4140
+..end lib/parser.y modeval..idc8fd0a7fcc
 
 ##### racc 1.4.5 generates ###
@@ -1127,6 +1135,6 @@
  5, 209, :_reduce_none,
  5, 209, :_reduce_none,
- 1, 211, :_reduce_none,
- 1, 211, :_reduce_none,
+ 1, 211, :_reduce_303,
+ 1, 211, :_reduce_304,
  0, 117, :_reduce_none,
  5, 117, :_reduce_306,
@@ -3362,11 +3370,21 @@
  # reduce 302 omitted
 
- # reduce 303 omitted
-
- # reduce 304 omitted
+module_eval <<'.,.,', 'lib/parser.y', 1000
+  def _reduce_303( val, _values, result )
+    result = val[0]
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 1004
+  def _reduce_304( val, _values, result )
+    result = val[0]
+   result
+  end
+.,.,
 
  # reduce 305 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 1005
+module_eval <<'.,.,', 'lib/parser.y', 1011
   def _reduce_306( val, _values, result )
     result = val[3]
@@ -3467,5 +3485,5 @@
  # reduce 352 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 1075
+module_eval <<'.,.,', 'lib/parser.y', 1081
   def _reduce_353( val, _values, result )
     result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN.new(:true_valid => true)
@@ -3474,5 +3492,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 1079
+module_eval <<'.,.,', 'lib/parser.y', 1085
   def _reduce_354( val, _values, result )
     result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN.new(:true_valid => false)
@@ -3481,5 +3499,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 1083
+module_eval <<'.,.,', 'lib/parser.y', 1089
   def _reduce_355( val, _values, result )
     result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN.new(:true_valid => true,:false_valid => false)
@@ -3488,5 +3506,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 1087
+module_eval <<'.,.,', 'lib/parser.y', 1093
   def _reduce_356( val, _values, result )
     result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN.new(:true_valid => false,:false_valid => true)
@@ -3495,5 +3513,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 1092
+module_eval <<'.,.,', 'lib/parser.y', 1098
   def _reduce_357( val, _values, result )
     result = val[0]
@@ -3502,5 +3520,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 1096
+module_eval <<'.,.,', 'lib/parser.y', 1102
   def _reduce_358( val, _values, result )
     raise 'Not implemented yet'
@@ -3509,5 +3527,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 1100
+module_eval <<'.,.,', 'lib/parser.y', 1106
   def _reduce_359( val, _values, result )
     raise 'Not implemented yet'
@@ -3526,5 +3544,5 @@
  # reduce 364 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 1113
+module_eval <<'.,.,', 'lib/parser.y', 1119
   def _reduce_365( val, _values, result )
     @in_interval = false
@@ -3534,5 +3552,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 1119
+module_eval <<'.,.,', 'lib/parser.y', 1125
   def _reduce_366( val, _values, result )
       result = val[0]
@@ -3541,5 +3559,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 1123
+module_eval <<'.,.,', 'lib/parser.y', 1129
   def _reduce_367( val, _values, result )
       result = val[0]
@@ -3556,5 +3574,5 @@
  # reduce 371 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 1138
+module_eval <<'.,.,', 'lib/parser.y', 1144
   def _reduce_372( val, _values, result )
       result = val[0]
@@ -3563,5 +3581,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 1143
+module_eval <<'.,.,', 'lib/parser.y', 1149
   def _reduce_373( val, _values, result )
       result = val[0]
@@ -3570,5 +3588,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 1148
+module_eval <<'.,.,', 'lib/parser.y', 1154
   def _reduce_374( val, _values, result )
     @@log.info("#{__FILE__}:#{__LINE__}, V_ATTRIBUTE_IDENTIFIER = #{word} at #{@filename}")
@@ -3578,5 +3596,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 1158
+module_eval <<'.,.,', 'lib/parser.y', 1164
   def _reduce_375( val, _values, result )
     result = val[0]