Index: ruby/trunk/rails/cancerehr/log/development.log
===================================================================
--- ruby/trunk/rails/cancerehr/log/development.log	(revision 59)
+++ ruby/trunk/rails/cancerehr/log/development.log	(revision 64)
@@ -3342,2 +3342,53 @@
 Rendering login/index
 Completed in 0.01986 (50 reqs/sec) | Rendering: 0.01734 (87%) | DB: 0.00000 (0%) | 200 OK [http://localhost/login]
+
+
+Processing LoginController#login (for 127.0.0.1 at 2008-05-16 22:42:10) [POST]
+  Session ID: BAh7CDoMdXNlcl9pZGkGOgxjc3JmX2lkIiU4ZjhjODI0ZmZjOGE3OTJkMTNi%0AMDIwOTdkZWVjY2U4YiIKZmxhc2hJQzonQWN0aW9uQ29udHJvbGxlcjo6Rmxh%0Ac2g6OkZsYXNoSGFzaHsABjoKQHVzZWR7AA%3D%3D--72046ec0ec8f1aba02705669ad74c71ad96a1d58
+  Parameters: {"name"=>"skoba", "commit"=>"Login", "authenticity_token"=>"e7e0df2215d122c93fcf3757bbc8092e22718a20", "action"=>"login", "controller"=>"login", "password"=>"sg2008"}
+  [4;35;1mUser Load (0.000383)[0m   [0mSELECT * FROM users WHERE (users."name" = 'skoba') LIMIT 1[0m
+Redirected to http://localhost:3000/login
+Completed in 0.05829 (17 reqs/sec) | DB: 0.00038 (0%) | 302 Found [http://localhost/login/login]
+
+
+Processing LoginController#index (for 127.0.0.1 at 2008-05-16 22:42:10) [GET]
+  Session ID: BAh7CDoMdXNlcl9pZGkGOgxjc3JmX2lkIiU4ZjhjODI0ZmZjOGE3OTJkMTNi%0AMDIwOTdkZWVjY2U4YiIKZmxhc2hJQzonQWN0aW9uQ29udHJvbGxlcjo6Rmxh%0Ac2g6OkZsYXNoSGFzaHsABjoKQHVzZWR7AA%3D%3D--72046ec0ec8f1aba02705669ad74c71ad96a1d58
+  Parameters: {"action"=>"index", "controller"=>"login"}
+Rendering login/index
+Completed in 0.00326 (306 reqs/sec) | Rendering: 0.00106 (32%) | DB: 0.00000 (0%) | 200 OK [http://localhost/login]
+
+
+Processing LoginController#login (for 127.0.0.1 at 2008-05-19 12:16:59) [POST]
+  Session ID: BAh7CDoMdXNlcl9pZGkGOgxjc3JmX2lkIiU4ZjhjODI0ZmZjOGE3OTJkMTNi%0AMDIwOTdkZWVjY2U4YiIKZmxhc2hJQzonQWN0aW9uQ29udHJvbGxlcjo6Rmxh%0Ac2g6OkZsYXNoSGFzaHsABjoKQHVzZWR7AA%3D%3D--72046ec0ec8f1aba02705669ad74c71ad96a1d58
+  Parameters: {"name"=>"skoba", "commit"=>"Login", "authenticity_token"=>"e7e0df2215d122c93fcf3757bbc8092e22718a20", "action"=>"login", "controller"=>"login", "password"=>"sg2008"}
+  [4;36;1mUser Load (0.000379)[0m   [0;1mSELECT * FROM users WHERE (users."name" = 'skoba') LIMIT 1[0m
+Redirected to http://localhost:3000/login
+Completed in 0.07246 (13 reqs/sec) | DB: 0.00038 (0%) | 302 Found [http://localhost/login/login]
+
+
+Processing LoginController#index (for 127.0.0.1 at 2008-05-19 12:16:59) [GET]
+  Session ID: BAh7CDoMdXNlcl9pZGkGOgxjc3JmX2lkIiU4ZjhjODI0ZmZjOGE3OTJkMTNi%0AMDIwOTdkZWVjY2U4YiIKZmxhc2hJQzonQWN0aW9uQ29udHJvbGxlcjo6Rmxh%0Ac2g6OkZsYXNoSGFzaHsABjoKQHVzZWR7AA%3D%3D--72046ec0ec8f1aba02705669ad74c71ad96a1d58
+  Parameters: {"action"=>"index", "controller"=>"login"}
+Rendering login/index
+Completed in 0.00299 (334 reqs/sec) | Rendering: 0.00077 (25%) | DB: 0.00000 (0%) | 200 OK [http://localhost/login]
+
+
+Processing LoginController#add_user (for 127.0.0.1 at 2008-05-19 12:21:22) [GET]
+  Session ID: BAh7CDoMdXNlcl9pZGkGOgxjc3JmX2lkIiU4ZjhjODI0ZmZjOGE3OTJkMTNi%0AMDIwOTdkZWVjY2U4YiIKZmxhc2hJQzonQWN0aW9uQ29udHJvbGxlcjo6Rmxh%0Ac2g6OkZsYXNoSGFzaHsABjoKQHVzZWR7AA%3D%3D--72046ec0ec8f1aba02705669ad74c71ad96a1d58
+  Parameters: {"action"=>"add_user", "controller"=>"login"}
+Rendering login/add_user
+Completed in 0.01203 (83 reqs/sec) | Rendering: 0.00260 (21%) | DB: 0.00000 (0%) | 200 OK [http://localhost/login/add_user]
+
+
+Processing LoginController#login (for 127.0.0.1 at 2008-05-21 22:23:26) [GET]
+  Session ID: BAh7CDoMdXNlcl9pZGkGOgxjc3JmX2lkIiU4ZjhjODI0ZmZjOGE3OTJkMTNi%0AMDIwOTdkZWVjY2U4YiIKZmxhc2hJQzonQWN0aW9uQ29udHJvbGxlcjo6Rmxh%0Ac2g6OkZsYXNoSGFzaHsABjoKQHVzZWR7AA%3D%3D--72046ec0ec8f1aba02705669ad74c71ad96a1d58
+  Parameters: {"action"=>"login", "controller"=>"login"}
+Rendering login/login
+Completed in 0.00519 (192 reqs/sec) | Rendering: 0.00289 (55%) | DB: 0.00000 (0%) | 200 OK [http://localhost/login/login]
+
+
+Processing LoginController#login (for 127.0.0.1 at 2008-05-26 08:28:33) [GET]
+  Session ID: BAh7CDoMdXNlcl9pZDA6DGNzcmZfaWQiJThmOGM4MjRmZmM4YTc5MmQxM2Iw%0AMjA5N2RlZWNjZThiIgpmbGFzaElDOidBY3Rpb25Db250cm9sbGVyOjpGbGFz%0AaDo6Rmxhc2hIYXNoewAGOgpAdXNlZHsA--0db3c15de2ffbc55a6075dd03739fb3b6c78daef
+  Parameters: {"action"=>"login", "controller"=>"login"}
+Rendering login/login
+Completed in 0.00587 (170 reqs/sec) | Rendering: 0.00353 (60%) | DB: 0.00000 (0%) | 200 OK [http://localhost/login/login]